using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Components4U.Net.Atom;
using System.Net;

namespace AtomSample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TabControl tabCtl;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.RichTextBox txtAbout;
		private System.Windows.Forms.Label lblCopy;
		private System.Windows.Forms.Label lblDemo;
		private System.Windows.Forms.TabPage tabPage2;
		internal System.Windows.Forms.GroupBox GroupBox1;
		internal System.Windows.Forms.PictureBox picBox;
		internal System.Windows.Forms.Button btnGet;
		internal System.Windows.Forms.GroupBox pnlMessages;
		internal System.Windows.Forms.ListView lstMessages;
		internal System.Windows.Forms.ColumnHeader clmDate;
		internal System.Windows.Forms.ColumnHeader clmMessage;
		internal System.Windows.Forms.GroupBox pnlNews;
		internal System.Windows.Forms.Panel pnlHeader;
		internal System.Windows.Forms.Label lblItemDate;
		private System.ComponentModel.IContainer components;
		internal System.Windows.Forms.ToolTip tltTip;
		private System.Windows.Forms.Panel panel1;
		internal System.Windows.Forms.ComboBox ddlURL;
		internal System.Windows.Forms.Label lblURL;
		internal System.Windows.Forms.TextBox txtItemDescription;
		internal System.Windows.Forms.Label lblItemTitle;
		protected Feed atmFeed;
		private System.Windows.Forms.Button btnProxy;
		private static ProxySetting proxy = new ProxySetting();

		public static ProxySetting Proxy
		{
			get
			{
				return proxy;
			}
		}

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.tabCtl = new System.Windows.Forms.TabControl();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.txtAbout = new System.Windows.Forms.RichTextBox();
			this.lblCopy = new System.Windows.Forms.Label();
			this.lblDemo = new System.Windows.Forms.Label();
			this.btnProxy = new System.Windows.Forms.Button();
			this.tabPage2 = new System.Windows.Forms.TabPage();
			this.pnlNews = new System.Windows.Forms.GroupBox();
			this.txtItemDescription = new System.Windows.Forms.TextBox();
			this.pnlHeader = new System.Windows.Forms.Panel();
			this.lblItemTitle = new System.Windows.Forms.Label();
			this.lblItemDate = new System.Windows.Forms.Label();
			this.pnlMessages = new System.Windows.Forms.GroupBox();
			this.lstMessages = new System.Windows.Forms.ListView();
			this.clmDate = new System.Windows.Forms.ColumnHeader();
			this.clmMessage = new System.Windows.Forms.ColumnHeader();
			this.GroupBox1 = new System.Windows.Forms.GroupBox();
			this.panel1 = new System.Windows.Forms.Panel();
			this.ddlURL = new System.Windows.Forms.ComboBox();
			this.lblURL = new System.Windows.Forms.Label();
			this.picBox = new System.Windows.Forms.PictureBox();
			this.btnGet = new System.Windows.Forms.Button();
			this.tltTip = new System.Windows.Forms.ToolTip(this.components);
			this.tabCtl.SuspendLayout();
			this.tabPage1.SuspendLayout();
			this.tabPage2.SuspendLayout();
			this.pnlNews.SuspendLayout();
			this.pnlHeader.SuspendLayout();
			this.pnlMessages.SuspendLayout();
			this.GroupBox1.SuspendLayout();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabCtl
			// 
			this.tabCtl.Controls.Add(this.tabPage1);
			this.tabCtl.Controls.Add(this.tabPage2);
			this.tabCtl.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabCtl.Location = new System.Drawing.Point(0, 0);
			this.tabCtl.Name = "tabCtl";
			this.tabCtl.SelectedIndex = 0;
			this.tabCtl.Size = new System.Drawing.Size(640, 525);
			this.tabCtl.TabIndex = 6;
			// 
			// tabPage1
			// 
			this.tabPage1.Controls.Add(this.txtAbout);
			this.tabPage1.Controls.Add(this.lblCopy);
			this.tabPage1.Controls.Add(this.lblDemo);
			this.tabPage1.Controls.Add(this.btnProxy);
			this.tabPage1.Location = new System.Drawing.Point(4, 22);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(632, 499);
			this.tabPage1.TabIndex = 0;
			this.tabPage1.Text = "Info";
			// 
			// txtAbout
			// 
			this.txtAbout.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtAbout.Font = new System.Drawing.Font("Verdana", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.txtAbout.ForeColor = System.Drawing.SystemColors.Desktop;
			this.txtAbout.Location = new System.Drawing.Point(0, 69);
			this.txtAbout.Name = "txtAbout";
			this.txtAbout.ReadOnly = true;
			this.txtAbout.ShowSelectionMargin = true;
			this.txtAbout.Size = new System.Drawing.Size(632, 430);
			this.txtAbout.TabIndex = 6;
			this.txtAbout.Text = @"Components4U is a fast growing software development company providing software developers with high quality and easy-to-use software components for Microsoft .NET platform. 

Components4U was created by professionals for professionals. Company's founders have more than 15 years experience in software development and design. We really understand programmer's needs and develop solutions, which make your work and life a lot easier. 

Our E-Commerce, Web, Business and Network software components will help you to save your time and money producing a wide range of .NET software applications. 
 
The key features we follow at Components4U: 
	Provide our clients only with high-quality products 
	Be oriented on our clients and their business needs 
	Support our clients during all phases of using our products 
	Be innovative and supply really cutting-edge solutions 

 Please visit our Web site http://www.Components4U.Net/";
			this.txtAbout.LinkClicked += new System.Windows.Forms.LinkClickedEventHandler(this.txtAbout_LinkClicked);
			// 
			// lblCopy
			// 
			this.lblCopy.Cursor = System.Windows.Forms.Cursors.Hand;
			this.lblCopy.Dock = System.Windows.Forms.DockStyle.Top;
			this.lblCopy.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Underline))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblCopy.ForeColor = System.Drawing.SystemColors.Desktop;
			this.lblCopy.Location = new System.Drawing.Point(0, 46);
			this.lblCopy.Name = "lblCopy";
			this.lblCopy.Size = new System.Drawing.Size(632, 23);
			this.lblCopy.TabIndex = 5;
			this.lblCopy.Text = "(C) Components4U 2005";
			this.lblCopy.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.lblCopy.Click += new System.EventHandler(this.lblCopy_Click);
			// 
			// lblDemo
			// 
			this.lblDemo.Dock = System.Windows.Forms.DockStyle.Top;
			this.lblDemo.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.lblDemo.ForeColor = System.Drawing.SystemColors.Desktop;
			this.lblDemo.Location = new System.Drawing.Point(0, 23);
			this.lblDemo.Name = "lblDemo";
			this.lblDemo.Size = new System.Drawing.Size(632, 23);
			this.lblDemo.TabIndex = 4;
			this.lblDemo.Text = "Atom Demo";
			this.lblDemo.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// btnProxy
			// 
			this.btnProxy.Dock = System.Windows.Forms.DockStyle.Top;
			this.btnProxy.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.btnProxy.Location = new System.Drawing.Point(0, 0);
			this.btnProxy.Name = "btnProxy";
			this.btnProxy.Size = new System.Drawing.Size(632, 23);
			this.btnProxy.TabIndex = 7;
			this.btnProxy.Text = "Proxy settings";
			this.btnProxy.Click += new System.EventHandler(this.btnProxy_Click);
			// 
			// tabPage2
			// 
			this.tabPage2.Controls.Add(this.pnlNews);
			this.tabPage2.Controls.Add(this.pnlMessages);
			this.tabPage2.Controls.Add(this.GroupBox1);
			this.tabPage2.Location = new System.Drawing.Point(4, 22);
			this.tabPage2.Name = "tabPage2";
			this.tabPage2.Size = new System.Drawing.Size(632, 499);
			this.tabPage2.TabIndex = 1;
			this.tabPage2.Text = "Atom";
			this.tabPage2.Visible = false;
			// 
			// pnlNews
			// 
			this.pnlNews.Controls.Add(this.txtItemDescription);
			this.pnlNews.Controls.Add(this.pnlHeader);
			this.pnlNews.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlNews.Location = new System.Drawing.Point(0, 312);
			this.pnlNews.Name = "pnlNews";
			this.pnlNews.Size = new System.Drawing.Size(632, 187);
			this.pnlNews.TabIndex = 3;
			this.pnlNews.TabStop = false;
			// 
			// txtItemDescription
			// 
			this.txtItemDescription.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtItemDescription.Location = new System.Drawing.Point(3, 56);
			this.txtItemDescription.Multiline = true;
			this.txtItemDescription.Name = "txtItemDescription";
			this.txtItemDescription.ReadOnly = true;
			this.txtItemDescription.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtItemDescription.Size = new System.Drawing.Size(626, 128);
			this.txtItemDescription.TabIndex = 3;
			this.txtItemDescription.Text = "";
			// 
			// pnlHeader
			// 
			this.pnlHeader.BackColor = System.Drawing.Color.LightSkyBlue;
			this.pnlHeader.Controls.Add(this.lblItemTitle);
			this.pnlHeader.Controls.Add(this.lblItemDate);
			this.pnlHeader.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlHeader.Location = new System.Drawing.Point(3, 16);
			this.pnlHeader.Name = "pnlHeader";
			this.pnlHeader.Size = new System.Drawing.Size(626, 40);
			this.pnlHeader.TabIndex = 0;
			// 
			// lblItemTitle
			// 
			this.lblItemTitle.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lblItemTitle.Location = new System.Drawing.Point(184, 0);
			this.lblItemTitle.Name = "lblItemTitle";
			this.lblItemTitle.Size = new System.Drawing.Size(442, 40);
			this.lblItemTitle.TabIndex = 3;
			// 
			// lblItemDate
			// 
			this.lblItemDate.Dock = System.Windows.Forms.DockStyle.Left;
			this.lblItemDate.Location = new System.Drawing.Point(0, 0);
			this.lblItemDate.Name = "lblItemDate";
			this.lblItemDate.Size = new System.Drawing.Size(184, 40);
			this.lblItemDate.TabIndex = 1;
			// 
			// pnlMessages
			// 
			this.pnlMessages.Controls.Add(this.lstMessages);
			this.pnlMessages.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlMessages.Location = new System.Drawing.Point(0, 56);
			this.pnlMessages.Name = "pnlMessages";
			this.pnlMessages.Size = new System.Drawing.Size(632, 256);
			this.pnlMessages.TabIndex = 2;
			this.pnlMessages.TabStop = false;
			this.pnlMessages.Text = "Messages";
			// 
			// lstMessages
			// 
			this.lstMessages.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						  this.clmDate,
																						  this.clmMessage});
			this.lstMessages.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lstMessages.FullRowSelect = true;
			this.lstMessages.GridLines = true;
			this.lstMessages.Location = new System.Drawing.Point(3, 16);
			this.lstMessages.Name = "lstMessages";
			this.lstMessages.Size = new System.Drawing.Size(626, 237);
			this.lstMessages.TabIndex = 0;
			this.lstMessages.View = System.Windows.Forms.View.Details;
			this.lstMessages.SelectedIndexChanged += new System.EventHandler(this.lstMessages_SelectedIndexChanged);
			// 
			// clmDate
			// 
			this.clmDate.Text = "Date";
			this.clmDate.Width = 142;
			// 
			// clmMessage
			// 
			this.clmMessage.Text = "Title";
			this.clmMessage.Width = 400;
			// 
			// GroupBox1
			// 
			this.GroupBox1.Controls.Add(this.panel1);
			this.GroupBox1.Controls.Add(this.picBox);
			this.GroupBox1.Controls.Add(this.btnGet);
			this.GroupBox1.Dock = System.Windows.Forms.DockStyle.Top;
			this.GroupBox1.Location = new System.Drawing.Point(0, 0);
			this.GroupBox1.Name = "GroupBox1";
			this.GroupBox1.Size = new System.Drawing.Size(632, 56);
			this.GroupBox1.TabIndex = 1;
			this.GroupBox1.TabStop = false;
			this.GroupBox1.Text = "Atom Resourse";
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.ddlURL);
			this.panel1.Controls.Add(this.lblURL);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(91, 16);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(466, 37);
			this.panel1.TabIndex = 5;
			// 
			// ddlURL
			// 
			this.ddlURL.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ddlURL.Location = new System.Drawing.Point(48, 8);
			this.ddlURL.Name = "ddlURL";
			this.ddlURL.Size = new System.Drawing.Size(408, 20);
			this.ddlURL.TabIndex = 5;
			this.ddlURL.Text = "http://";
			// 
			// lblURL
			// 
			this.lblURL.Location = new System.Drawing.Point(8, 8);
			this.lblURL.Name = "lblURL";
			this.lblURL.Size = new System.Drawing.Size(40, 16);
			this.lblURL.TabIndex = 4;
			this.lblURL.Text = "URL : ";
			// 
			// picBox
			// 
			this.picBox.Dock = System.Windows.Forms.DockStyle.Left;
			this.picBox.Location = new System.Drawing.Point(3, 16);
			this.picBox.Name = "picBox";
			this.picBox.Size = new System.Drawing.Size(88, 37);
			this.picBox.TabIndex = 4;
			this.picBox.TabStop = false;
			this.picBox.Visible = false;
			// 
			// btnGet
			// 
			this.btnGet.Dock = System.Windows.Forms.DockStyle.Right;
			this.btnGet.Location = new System.Drawing.Point(557, 16);
			this.btnGet.Name = "btnGet";
			this.btnGet.Size = new System.Drawing.Size(72, 37);
			this.btnGet.TabIndex = 2;
			this.btnGet.Text = "Get messages";
			this.btnGet.Click += new System.EventHandler(this.btnGet_Click);
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(640, 525);
			this.Controls.Add(this.tabCtl);
			this.Name = "frmMain";
			this.Text = "Atom Demo (C) Components4U 2005";
			this.Load += new System.EventHandler(this.frmMain_Load);
			this.tabCtl.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			this.tabPage2.ResumeLayout(false);
			this.pnlNews.ResumeLayout(false);
			this.pnlHeader.ResumeLayout(false);
			this.pnlMessages.ResumeLayout(false);
			this.GroupBox1.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void lblCopy_Click(object sender, System.EventArgs e)
		{
			System.Diagnostics.Process.Start("www.Components4U.Net");
		}

		private void txtAbout_LinkClicked(object sender, System.Windows.Forms.LinkClickedEventArgs e)
		{
			System.Diagnostics.Process.Start(e.LinkText);
		}

		private void frmMain_Load(object sender, System.EventArgs e)
		{
			ddlURL.Items.Add("http://www.atomenabled.org/atom.xml");
			ddlURL.Items.Add("http://use.perl.org/index.atom");
			ddlURL.Items.Add("http://bblfish.net/blog/blog.atom");
			ddlURL.Items.Add("http://www.snellspace.com/atom/atomcast.php?url=http://www.itconversations.com/rss/category-rss.php%3Fk=technation%26e=1");
			
			pnlMessages.Enabled = false;
			pnlNews.Enabled = false;
			picBox.Width = 0;
			picBox.Height = 0;
		}

		private void btnGet_Click(object sender, System.EventArgs e)
		{
			this.Cursor = Cursors.WaitCursor;
			lstMessages.Items.Clear();
			atmFeed = new Feed();
			pnlNews.Enabled = false;
			if( Proxy.UseProxy )
			{
				UriBuilder url = new UriBuilder("http",Proxy.Address,Proxy.Port);
				WebProxy wp = new WebProxy(url.Uri, Proxy.BypassLocal);
				GlobalProxySelection.Select = wp;
			}
			else
				GlobalProxySelection.Select = WebProxy.GetDefaultProxy();
			try
			{
				atmFeed.Load(ddlURL.Text.Trim());
				atmFeed.SaveAtom("text.xml");
			}
			catch(Exception ex )
			{
				MessageBox.Show(ex.Message, "Error in retriving the information", MessageBoxButtons.OK, MessageBoxIcon.Error);
				pnlMessages.Enabled = false;
				pnlNews.Enabled = false;
				return;
			}

			foreach(Entry itm in atmFeed.Entries)
			{
				ListViewItem lstItem = new ListViewItem(new string[] {itm.Published.ToLongDateString() + " " + itm.Published.ToLongTimeString(), itm.Title});
				lstMessages.Items.Add(lstItem);
			}
			if (!atmFeed.Logo.Equals("") || !atmFeed.Icon.Equals(""))
			{
				System.Net.WebClient web = new System.Net.WebClient();
				try
				{
					picBox.Visible = true;
					if(!atmFeed.Logo.Equals(""))
						picBox.Image = Image.FromStream(new System.IO.MemoryStream(web.DownloadData(atmFeed.Logo)));
					else
						picBox.Image = Image.FromStream(new System.IO.MemoryStream(web.DownloadData(atmFeed.Icon)));
					picBox.Width = picBox.Image.Width;
					picBox.Height = picBox.Image.Height;
					tltTip.SetToolTip(picBox, atmFeed.Title + "\n" + atmFeed.SubTitle + "\n" + atmFeed.Rights);
				}	
				catch (Exception ex)
				{
					picBox.Visible = false;
				}
			}
			else
				picBox.Visible = false;
			pnlMessages.Enabled = true;
			this.Cursor = Cursors.Default;
		}

		private void lnkItemLink_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			if ( e.Link.LinkData != null)
				System.Diagnostics.Process.Start((string)e.Link.LinkData);
		}

		protected void ShowMessage()
		{
			Entry curItem = atmFeed.Entries[lstMessages.FocusedItem.Index];
			lblItemDate.Text = curItem.Published.ToLongDateString() + " " + curItem.Published.ToLongTimeString();
			lblItemTitle.Text = curItem.Title;
			if(!curItem.Content.Equals(""))
				txtItemDescription.Text = curItem.Content;
			else
				txtItemDescription.Text = curItem.Summary;
			pnlNews.Enabled = true;
		}

		private void lstMessages_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			ShowMessage();
		}

		private void btnProxy_Click(object sender, System.EventArgs e)
		{
			frmProxySettings _frmProxy = new frmProxySettings();
			_frmProxy.ShowDialog();
			_frmProxy.Dispose();
		}
	}
}
